/* #region  [ - import - ] */
import React, { PureComponent } from "react";
import { Card, Col, Container, Row, Input, FormGroup } from "reactstrap";
import { Drawer, Button, Icon, Form, Modal } from "antd";
import { AgGridReact } from "ag-grid-react";
import "ag-grid-community/dist/styles/ag-grid.css";
import "ag-grid-community/dist/styles/ag-theme-balham.css";
import FormItem from "antd/lib/form/FormItem";

/* #endregion */

class Print extends PureComponent {
 
    /* #region  [ - ctor - ] */
  constructor(props) {
    super(props);

    this.state = {
      columnDefs: [
        { headername: "Id", field: "id", hide: true },
        { headername: "Title", field: "title" },
        { headername: "Description", field: "descriptionRow" },
        { headername: "SectionTypeRef", field: "sectionTypeRef", hide: true },
      ],
      rowData: [
        {
          id: "1",
          sectionTypeRef: "1",
          title: "Toyota",
          descriptionRow: "Celica",
        },
        {
          id: "2",
          sectionTypeRef: "1",
          title: "Ford",
          descriptionRow: "Mondeo",
        },
        {
          id: "3",
          sectionTypeRef: "1",
          title: "Porsche",
          descriptionRow: "Boxter",
        },
      ],
    };
  }
  /* #endregion */

  /* #region  [- onPrint -] */

  onPrint = async () => {
    var data = {
      sectionTypeList: { ...this.state.rowData },
    };

    var report = new window.Stimulsoft.Report.StiReport();
    report.loadFile("../public/rp_sectionTypee.mrt");

    var dssectionTypeList = new window.Stimulsoft.System.Data.DataSet();
    dssectionTypeList.readJson(JSON.stringify(data));

    report.regData("sectionTypeList", dssectionTypeList);
    report.dictionary.synchronize();

    report.renderAsync(() => {
      report.print();
    });
  };
  /* #endregion */

  render() {
    return (
      <Container fluid id="container">
        <Row>
          <Col>
            <Card>
              <Form>
                <FormItem>
                  <Button
                    name="print"
                    onClick={this.onPrint}
                    style={{
                      width: "94px",
                      backgroundColor: "yellow",
                      marginTop: "20px",
                    }}
                  >
                    print
                  </Button>
                </FormItem>

                <Form.Item>
                  <div
                    className="ag-theme-balham"
                    style={{
                      height: "150px",
                      width: "410px",
                      marginLeft: "460px",
                      marginTop: "30px",
                    }}
                  >
                    <AgGridReact
                      columnDefs={this.state.columnDefs}
                      rowData={this.state.rowData}
                    ></AgGridReact>
                  </div>
                </Form.Item>
              </Form>
            </Card>
          </Col>
        </Row>
      </Container>
    );
  }
}

export default Print;
